﻿using Infragistics.Windows;
using Infragistics.Windows.DockManager;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XamDockManager_panes
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private PaneLocation beforeDragLocation;
        private PaneLocation afterDragLocation;

        public MainWindow()
        {
            InitializeComponent();
        }

        private void dockManager_PaneDragStarting(object sender, Infragistics.Windows.DockManager.Events.PaneDragStartingEventArgs e)
        {
            var sp = Utilities.GetAncestorFromType(e.RootPane, typeof(SplitPane), false) as SplitPane;
            if (sp == null)
                sp = Utilities.GetDescendantFromType(e.RootPane, typeof(SplitPane), false) as SplitPane;

            var anyCp = Utilities.GetDescendantFromType(sp, typeof(ContentPane), false) as ContentPane;

            beforeDragLocation = anyCp.PaneLocation;
        }

        private void dockManager_PaneDragEnded(object sender, Infragistics.Windows.DockManager.Events.PaneDragEndedEventArgs e)
        {
            afterDragLocation = (e.Panes.FirstOrDefault() as ContentPane).PaneLocation;

            if (beforeDragLocation != afterDragLocation && 
                (beforeDragLocation == PaneLocation.Floating || afterDragLocation == PaneLocation.Floating))
            {
                MessageBox.Show("Pane location changed from '" + beforeDragLocation.ToString()
                                + "' to '" + afterDragLocation.ToString() + "'.");
            }
        }
    }
}
